#pragma option -ml
#pragma option -3
#pragma option -w
#pragma option -d
#pragma option -G
#pragma option -Obgeilmptv
#undef NULL
#define NULL ((void far *)0L)

typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef signed short SWORD;
typedef unsigned long DWORD;

#define wholemask 1 /* do we mask the whole screen or just scanlines? */

#define NR far

static void huge *malloc(DWORD bytecount)
{
    WORD tmp = (bytecount + 15) >> 4;
    void *p = NULL;
    _asm {
        mov bx, tmp
        mov ah, 48h
        int 21h
        jc fail
        mov word ptr (p+2), ax
    }
fail:
    return p;
}
static void free(void *p)
{
    _asm {
        les ax, p
        mov ah, 49h
        int 21h
    }
}
static void memcpy8(void *dest, const void *src)
{
    ((DWORD *)dest)[0] = ((const DWORD *)src)[0];
    ((DWORD *)dest)[1] = ((const DWORD *)src)[1];
}
static void memcpy(void *dest, const void *src, unsigned count)
{
    unsigned a;
    for(a=0; a<count; ++a)
        ((BYTE *)dest)[a] = ((const BYTE *)src)[a];
}
static void dwcopy(BYTE *dest, const DWORD *src, unsigned dwcount)
{
    unsigned a;
    for(a=0; a<dwcount; ++a)
        ((DWORD *)dest)[a] = src[a];
}

typedef struct
{
    WORD xsize;
    WORD ysize;
    BYTE data[sizeof(unsigned)];
} basicbox;


/* xsize ja ysize ovat aina 16:n kerrannaisia.                         */
/* Tm funktio varaa (xsize+16) * (ysize+16) kokoisen bufferin, johon */
/* voidaan piirt putboxilla. Se on se taustakuva, jota voidaan       */
/* skrollata. drawscreen():n piirtmn nytn koko on xsize * ysize.   */
/* Palauttaa 0, jos muistin varaus onnistui oikein. */
extern int far initscreen(WORD xsize, WORD ysize);

/* Tm vapauttaa varatut resurssit. */
extern void far donescreen(void);

/* Piirt taustapuskuriin. */
extern void far putbox(unsigned xpos, unsigned ypos, const basicbox NR *data);
            
/* Tm tyhjent sprite-asetukset seuraavaa framea varten. *
 * Tyhjentminen ei ole pakollista.                         */
extern void far clearsprites(void);

/* Listn sprite taustalle. */
extern void far addbacksprite(SWORD xpos, SWORD ypos, const basicbox NR *data);

/* Listn sprite edustalle. */
extern void far addforesprite(SWORD xpos, SWORD ypos, const basicbox NR *data);

/* Piirt nytn. x ja y ovat skrollauspositiota kuvaavat luvut,     *
 * osoittavat siis taustapuskuriin. Puskuri wrapataan piirrettess   *
 * sek pystysuunnassa ett vaakasuunnassa.                           *
 * Spritet piirretn samalla, mutta nm x ja y eivt vaikuta        *
 * spritejen positioihin.                                             *
/* Nytt on standardinmukaisessa vga-13h-moodissa.                   */
extern void far drawscreen(WORD xsc, WORD ysc, WORD scrx1, WORD scry1);

extern void far genpixmask(basicbox NR *data);

typedef struct
{
    char isback;
    SWORD xpos, ypos;
    WORD xsize, ysize;
    const BYTE NR *data;
} sprite;

static WORD scrxs, scrys,   xs4;
static WORD scrvxs, scrvys, vxs4;
static BYTE huge *scrvp; /* Screen virtual buffer pointer */
static DWORD *SLBuffer;  /* Scanline buffer - scrvxs+32   */
#if wholemask
static BYTE huge *scrmp; /* Screen mask buffer pointer    */
#else
static BYTE *scrvm;      /* Scanline mask buffer */
#endif
static sprite sprites[256];
static unsigned sprcount = 0;

static BYTE far *const vidptr = (BYTE far *)0xA0000000UL;

static DWORD lmul(WORD a, WORD b)
{
    return (DWORD)a * b;
}

int far initscreen(WORD xsize, WORD ysize)
{
    DWORD vpsize;
    WORD slsize;
    #if !wholemask
    WORD smsize;
    #endif

    scrxs = xsize; scrvxs = scrxs + 16;
    scrys = ysize; scrvys = scrys + 16;
    vpsize = lmul(scrvxs, scrvys);
    slsize = scrvxs + 32;
    #if !wholemask
    smsize = scrvxs;
    #endif

    #if wholemask
    scrvp = (BYTE huge *)malloc(vpsize + slsize + vpsize);
    #else
    scrvp = (BYTE huge *)malloc(vpsize + slsize + smsize);
    #endif
    if(!scrvp)return -1;
    SLBuffer = (DWORD *)(scrvp + vpsize);
    #if wholemask
    scrmp = (BYTE huge *)(scrvp + vpsize + slsize);
    #else
    scrvm = (BYTE *)(scrvp + vpsize + slsize);
    #endif

    xs4 = scrxs / 4;
    vxs4 = scrvxs / 4;

    return 0;
}
void far donescreen(void)
{
    free(scrvp);
}
static void sortsprites(void)
{
    unsigned ind1 = 1;
    if(!sprcount)return;
    while(ind1 <= sprcount-1)
    {
        unsigned ind2 = ind1;
        while(ind2 > 0)
        {
            unsigned nextind2 = ind2-1;
            sprite tmp;
            if(sprites[ind2].ypos >= sprites[nextind2].ypos)break;
         
            memcpy(&tmp, &sprites[ind2], sizeof tmp);
            memcpy(&sprites[ind2], &sprites[nextind2], sizeof tmp);
            memcpy(&sprites[nextind2], &tmp, sizeof tmp);
         
            ind2 = nextind2;
        }
        ++ind1;
    }
}

void far drawscreen(WORD xsc, WORD ysc, WORD scrx1, WORD scry1)
{
    sortsprites();
 
    xsc %= scrvxs;
    
    {
     WORD ekasprite = 0;
     WORD y, yy=ysc;
     for(y=0; y<scrys; ++y)
     {
        yy %= scrvys;
        
        {
         WORD x;
         BYTE *sp = (BYTE *)(scrvp + lmul(yy, scrvxs));
         for(x=0; x<vxs4+4; ++x)SLBuffer[x]=0;

         #if 1
         // Draw background sprites
         for(x=ekasprite; x<sprcount; ++x)
         {
            if(y < sprites[x].ypos)break;
            if(sprites[x].isback == 1)
            {
                WORD y1 = y - sprites[x].ypos; // Y-positio spriten sisll.
                if(y1 >= sprites[x].ysize)continue;
                #if 0
                {
                 const BYTE *d = sprites[x].data + y1 * sprites[x].xsize;
                 memcpy((BYTE *)SLBuffer + 16 + sprites[x].xpos, d, sprites[x].xsize);
                }
                #else
                {
                 WORD xsize = sprites[x].xsize;
                 const DWORD *data = (const DWORD *)(sprites[x].data +  y1                   * xsize);
                 const DWORD *mask = (const DWORD *)(sprites[x].data + (y1+sprites[x].ysize) * xsize);
                 DWORD *p = (DWORD *)((BYTE *)SLBuffer + 16 + sprites[x].xpos);
                 WORD a;
                 for(a=0; a<xsize/4; ++a)
                    p[a] = (p[a] & mask[a]) | data[a];
                }
                #endif
            }
         }
         #endif

         // Draw the wall
         #if wholemask
         {
          const DWORD *taus = (DWORD *)sp;
          const DWORD *mask = (DWORD *)(scrmp + lmul(yy, scrvxs));
          BYTE shift = (xsc % 4) * 8;
          BYTE rshift = 32 - shift;
          WORD tx;
          for(x=0, tx=xsc/4; x<xs4; ++x)
          {
            WORD next_tx = tx+1; if(next_tx==vxs4)next_tx=0;
            {
             DWORD t = (taus[tx] >> shift);if(shift)t |= (taus[next_tx] << rshift);
             {
              DWORD m = (mask[tx] >> shift);if(shift)m |= (mask[next_tx] << rshift);
              SLBuffer[x+4] = (SLBuffer[x+4] & m) | t;
             }
             //SLBuffer[x+4] = m;
            }
            tx = next_tx;
          }
         }
         #else
         {
          BYTE *dest = (BYTE *)&SLBuffer[4];
          WORD xx = xsc;
          for(x=0; x<scrxs; ++x)
          {
            xx %= scrvxs;
            if(sp[xx])
            {
                dest[x] = sp[xx];
            }
            ++xx;
          }
         }
         #endif


         #if 1
         // Draw the foreground sprites
         for(x=ekasprite; x<sprcount; ++x)
         {
            if(y < sprites[x].ypos)break;
            if(sprites[x].isback == 0)
            {
                WORD y1 = y - sprites[x].ypos; // Y-positio spriten sisll.
                if(y1 >= sprites[x].ysize)continue;
                {
                 WORD xsize = sprites[x].xsize;
                 const DWORD *data = (const DWORD *)(sprites[x].data +  y1                   * xsize);
                 const DWORD *mask = (const DWORD *)(sprites[x].data + (y1+sprites[x].ysize) * xsize);
                 DWORD *p = (DWORD *)((BYTE *)SLBuffer + 16 + sprites[x].xpos);
                 WORD a;
                 for(a=0; a<xsize/4; ++a)
                    p[a] = (p[a] & mask[a]) | data[a];
                }
            }
         }
         #endif
         
         dwcopy(&vidptr[scrx1+(scry1+y)*320U], &SLBuffer[4], xs4);
        }    
        ++yy;
     }
    }
}

void far clearsprites(void)
{
    sprcount = 0;
}
void far addbacksprite(SWORD xpos, SWORD ypos, const basicbox NR *data)
{
    if(sprcount==256 || xpos<-16 || xpos+data->xsize/8 >= scrvxs)return;
    sprites[sprcount].isback = 1;
    sprites[sprcount].xpos = xpos;
    sprites[sprcount].ypos = ypos;
    sprites[sprcount].xsize = data->xsize/8;
    sprites[sprcount].ysize = data->ysize;
    sprites[sprcount].data = data->data;
    ++sprcount;
}
void far addforesprite(SWORD xpos, SWORD ypos, const basicbox NR *data)
{
    if(sprcount==256 || xpos<-16 || xpos+data->xsize/8 >= scrvxs)return;
    sprites[sprcount].isback = 0;
    sprites[sprcount].xpos = xpos;
    sprites[sprcount].ypos = ypos;
    sprites[sprcount].xsize = data->xsize/8;
    sprites[sprcount].ysize = data->ysize;
    sprites[sprcount].data = data->data;
    ++sprcount;
}
void far genpixmask(basicbox NR *data)
{
    WORD count = (data->xsize/8) * data->ysize;
    const BYTE *d = &data->data[0];
    BYTE *m = &data->data[count];
    WORD a;
    for(a=0; a<count; ++a)
        m[a] = d[a] ? 0 : 255;
}
/* Just a debugging function
int readbyte(WORD ofs, const BYTE NR *data)
{
    return data[ofs];
}*/

void far putbox(unsigned xpos, unsigned ypos, const basicbox NR *data)
{
    WORD xs = data->xsize/8;
    WORD ys = data->ysize;
    WORD y;
    WORD yp = ypos;
    const BYTE NR *p = &data->data[0];
#if wholemask
    const BYTE NR *m = &data->data[0 + xs*ys];
#endif

    for(y=0; ; )
    {
        WORD x=0, xp = xpos;
        DWORD offs = xp + lmul(yp, scrvxs);
        BYTE huge *sp = scrvp+offs;
#if wholemask
        BYTE huge *mp = scrmp+offs;
#endif
        for(; ; )
        {
            memcpy8(sp, p); p += 8;
#if wholemask
            memcpy8(mp, m); m += 8;
#endif
            x += 8; if(x >= xs)break;
            xp += 8;
            if(xp >= scrvxs)
            {
                xp -= scrvxs;
                offs = xp + lmul(yp, scrvxs);
                sp = scrvp+offs;
#if wholemask
                mp = scrmp+offs;
#endif
            }
            else
            {
                sp += 8;
                mp += 8;
            }
        }
        ++y; if(y >= ys)break;
        ++yp; if(yp >= scrvys) yp = 0;
    }
}
